#include <iostream.h>
#include "Config.h"
#include "VModelChecker.h"
#include "VModelDocumenter.h"
#include "VSimReporter.h"
#include "Model.h"
#include "Sched.h"
#include "VisMostCrowdedStreet.h"

#include <fstream.h>
ofstream output("Output.txt");

void main(int argc, char* argv[])
{

	buildModel();
	
	// Model checking:
	output<<"Model checking:\n================\n\n";
	Visitor* v = new VisModelChecker(&output);
	Model::Instance()->accept(v);
	delete v;
	cout<<"\nPress <Enter> to continue...";
	cin.get();
	output<<"\n\n";

	// Model documenting:
	output<<"Model documenting:\n===================\n\n";
	v = new VisModelDocumenter(&output);
	Model::Instance()->accept(v);
	delete v;
	cout<<"\nPress <Enter> to continue...";
	cin.get();
	output<<"\n\n";

	// Simulation:
	while (Scheduler::Instance()->getCurTime()<=5000.0)
		Scheduler::Instance()->processNow();
	// Simulation report:
	output<<"Model simulation:\n===================\n\n";
	output<<"Current simulation time: "<<Scheduler::Instance()->getCurTime()<<"\n";
	v = new VisSimulationReporter(&output);
	Model::Instance()->accept(v);
	delete v;
	cout<<"\nPress <Enter> to continue...";
	cin.get();
	output<<"\n\n";

	// prvi nacin, koriscenjem postojeceg pokazivaca na Visitor
	v = new VisMostCrowdedStreet(3);
	Model::Instance()->accept(v);
	((VisMostCrowdedStreet*)v)->report();
	delete v;

	// drugi nacin, koriscenjem pokazivaca na VisMostCrowdedStreet
	VisMostCrowdedStreet* pVisMCS = new VisMostCrowdedStreet(3);
	Model::Instance()->accept(pVisMCS);
	pVisMCS->report();
	delete pVisMCS;
}
