//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3C8E008C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3C8E008C.cm

//## begin module%3EEB3C8E008C.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3C8E008C.cp

//## Module: AbstractConcepts%3EEB3C8E008C; Package specification
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Abstract Concepts\AbstractConcepts.h

#ifndef AbstractConcepts_h
#define AbstractConcepts_h 1

//## begin module%3EEB3C8E008C.additionalIncludes preserve=no
//## end module%3EEB3C8E008C.additionalIncludes

//## begin module%3EEB3C8E008C.includes preserve=yes
#include "Types.h"
#include "Interfaces.h"
//## end module%3EEB3C8E008C.includes

//## begin module%3EEB3C8E008C.declarations preserve=no
//## end module%3EEB3C8E008C.declarations

//## begin module%3EEB3C8E008C.additionalDeclarations preserve=yes
class Visitor;
class RandomGenerator;
//## end module%3EEB3C8E008C.additionalDeclarations


//## begin ModelElement%3EE081050190.preface preserve=yes
//## end ModelElement%3EE081050190.preface

//## Class: ModelElement%3EE081050190; Abstract
//	Abstract generalization of all elements in the model.
//## Category: Traffic Modeling and Simulation::Concepts::Abstract Concepts%3EE0C06900BE
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class ModelElement 
{
  //## begin ModelElement%3EE081050190.initialDeclarations preserve=yes
  //## end ModelElement%3EE081050190.initialDeclarations

  public:
    //## Destructor (specified)
      //## Operation: ~ModelElement%3EEB247C00DC
      //	Destructor. Removes this Model Element from the Model.
      virtual ~ModelElement ();


    //## Other Operations (specified)
      //## Operation: accept%3EEB0F3800AA
      //	Abstract. Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis) = 0;

      //## Operation: getID%3EEB0EAE012C
      //	Returns the internally generated and unique ID of the
      //	Model Element.
      virtual MEID getID ();

      //## Operation: getName%3EED840C0320
      //	Returns the name of the Model Element.
      virtual String getName ();

      //## Operation: setName%3EED84290244
      //	Sets the name of the Model Element.
      virtual void setName (String newVal);

      //## Operation: getDescr%3EED844800E6
      //	Returns the description of the Model Element.
      virtual String getDescr ();

      //## Operation: setDescr%3EED844800E7
      //	Sets the description of the Model Element.
      virtual void setDescr (String newVal);

    // Additional Public Declarations
      //## begin ModelElement%3EE081050190.public preserve=yes
      //## end ModelElement%3EE081050190.public

  protected:
    //## Constructors (specified)
      //## Operation: ModelElement%3EEB246502BC
      //	Constructor. Adds this Model Element to the Model.
      ModelElement ();

    // Additional Protected Declarations
      //## begin ModelElement%3EE081050190.protected preserve=yes
      //## end ModelElement%3EE081050190.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: idCounter%3EEB0E850294
      //	Internal Model Element ID generator. Static.
      //## begin ModelElement::idCounter%3EEB0E850294.attr preserve=no  private: static MEID {UA} 0
      static MEID idCounter;
      //## end ModelElement::idCounter%3EEB0E850294.attr

      //## Attribute: id%3EEB0E53015E
      //	Internally generated ID of a Model Element.
      //## begin ModelElement::id%3EEB0E53015E.attr preserve=no  private: MEID {UA} ++idCounter
      MEID id;
      //## end ModelElement::id%3EEB0E53015E.attr

      //## Attribute: name%3EE0811E0294
      //	The name of the element.
      //## begin ModelElement::name%3EE0811E0294.attr preserve=no  private: String {UA} 
      String name;
      //## end ModelElement::name%3EE0811E0294.attr

      //## Attribute: descr%3EE0813701EA
      //	The description of the element.
      //## begin ModelElement::descr%3EE0813701EA.attr preserve=no  private: String {UA} 
      String descr;
      //## end ModelElement::descr%3EE0813701EA.attr

    // Additional Private Declarations
      //## begin ModelElement%3EE081050190.private preserve=yes
      //## end ModelElement%3EE081050190.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin ModelElement%3EE081050190.implementation preserve=yes
      //## end ModelElement%3EE081050190.implementation

};

//## begin ModelElement%3EE081050190.postscript preserve=yes
//## end ModelElement%3EE081050190.postscript

//## begin FlowElement%3EE082C00096.preface preserve=yes
//## end FlowElement%3EE082C00096.preface

//## Class: FlowElement%3EE082C00096; Abstract
//	Abstract generalization of Model Elements that generate,
//	transport, or accept traffic flow.
//## Category: Traffic Modeling and Simulation::Concepts::Abstract Concepts%3EE0C06900BE
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Persistence: Transient
//## Cardinality/Multiplicity: n

#define VEHICLE_COUNT 5

class FlowElement : public ModelElement  //## Inherits: <unnamed>%3EE083F20212
{
  //## begin FlowElement%3EE082C00096.initialDeclarations preserve=yes
  //## end FlowElement%3EE082C00096.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: acceptFlow%3EE0834302BC
      //	Accepts one flow item (a vehicle occurrence). Increments
      //	the counter and invokes process(). Template Method DP.
      virtual void acceptFlow ();

      //## Operation: getNumOfOccurrences%3EE0ABE00302
      //	Returns the total number of transported occurrences.
      virtual unsigned long getNumOfOccurrences ();

      //## Operation: resetCounter%3EE0ABE00334
      //	Resets the counter of transported occurrences.
      virtual void resetCounter ();

    // Data Members for Associations

      //## Association: Traffic Modeling and Simulation::Concepts::Abstract Concepts::flow%3EE0822200BE
      //## Role: FlowElement::target%3EE08225028A
      //## begin FlowElement::target%3EE08225028A.role preserve=no  public: FlowElement {* -> 0..1RFHAN}
      FlowElement *target;
      //## end FlowElement::target%3EE08225028A.role

    // Additional Public Declarations
      //## begin FlowElement%3EE082C00096.public preserve=yes
      //## end FlowElement%3EE082C00096.public

	  Time getTotalTime() { return total; }

  protected:
    //## Constructors (specified)
      //## Operation: FlowElement%3EE0ABBF0064
      //	Constructor.
      FlowElement ();


    //## Other Operations (specified)
      //## Operation: process%3EE0AC1B021C
      //	Processes an occurrence. To be redefined in derived
      //	classes.
      virtual void process ();

      //## Operation: send%3EE0A68902DA
      //	Sends a vehicle occurrence to the target Flow Element.
      virtual void send ();

    // Data Members for Class Attributes

      //## Attribute: counter%3EE0ABAC032A
      //	The counter of transported occurrences.
      //## begin FlowElement::counter%3EE0ABAC032A.attr preserve=no  protected: unsigned long {UA} 0
      unsigned long counter;
      // Counter of occurences curently in this Flow Element
      unsigned long counter1;
      Time t1, t2, total;
      //## end FlowElement::counter%3EE0ABAC032A.attr

    // Additional Protected Declarations
      //## begin FlowElement%3EE082C00096.protected preserve=yes
      //## end FlowElement%3EE082C00096.protected

  private:
    // Additional Private Declarations
      //## begin FlowElement%3EE082C00096.private preserve=yes
      //## end FlowElement%3EE082C00096.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin FlowElement%3EE082C00096.implementation preserve=yes
      //## end FlowElement%3EE082C00096.implementation

};

//## begin FlowElement%3EE082C00096.postscript preserve=yes
//## end FlowElement%3EE082C00096.postscript

//## begin ControlElement%3EE083CC0316.preface preserve=yes
//## end ControlElement%3EE083CC0316.preface

//## Class: ControlElement%3EE083CC0316; Abstract
//	Abstract generalization og Model Elements that control
//	traffic flow (e.g. a traffic light).
//## Category: Traffic Modeling and Simulation::Concepts::Abstract Concepts%3EE0C06900BE
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Persistence: Transient
//## Cardinality/Multiplicity: n

//## Uses: <unnamed>%3EE0870F0262;IFlowSource { -> F}

class ControlElement : public ModelElement  //## Inherits: <unnamed>%3EE083F30384
{
  //## begin ControlElement%3EE083CC0316.initialDeclarations preserve=yes
  //## end ControlElement%3EE083CC0316.initialDeclarations

  public:
    // Additional Public Declarations
      //## begin ControlElement%3EE083CC0316.public preserve=yes
      //## end ControlElement%3EE083CC0316.public

  protected:
    // Additional Protected Declarations
      //## begin ControlElement%3EE083CC0316.protected preserve=yes
      //## end ControlElement%3EE083CC0316.protected

  private:
    // Additional Private Declarations
      //## begin ControlElement%3EE083CC0316.private preserve=yes
      //## end ControlElement%3EE083CC0316.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin ControlElement%3EE083CC0316.implementation preserve=yes
      //## end ControlElement%3EE083CC0316.implementation

};

//## begin ControlElement%3EE083CC0316.postscript preserve=yes
//## end ControlElement%3EE083CC0316.postscript

//## begin RandomTimedFlowElement%3EE08BB1030C.preface preserve=yes
//## end RandomTimedFlowElement%3EE08BB1030C.preface

//## Class: RandomTimedFlowElement%3EE08BB1030C; Abstract
//	Abstract generalization of Flow Elements that have a
//	random timed flow service, generation, or delay.
//## Category: Traffic Modeling and Simulation::Concepts::Abstract Concepts%3EE0C06900BE
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class RandomTimedFlowElement : public FlowElement, //## Inherits: <unnamed>%3EE08C580028
                               	public ITimedElement  //## Inherits: <unnamed>%3EED8F60028A
{
  //## begin RandomTimedFlowElement%3EE08BB1030C.initialDeclarations preserve=yes
  //## end RandomTimedFlowElement%3EE08BB1030C.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: getRndGen%3EEE24A203AC
      //	Returns the associated random generator.
      virtual RandomGenerator* getRndGen ();

      //## Operation: notify%3EE88EC10320
      //	Notifies the receiver of the Event that the requested
      //	time delay has elapsed, or the time-scheduled Event has
      //	occurred.
      virtual void notify (ID id	// Auxiliary identification of the Event.
      ) = 0;

    // Additional Public Declarations
      //## begin RandomTimedFlowElement%3EE08BB1030C.public preserve=yes
      //## end RandomTimedFlowElement%3EE08BB1030C.public

  protected:
    //## Constructors (specified)
      //## Operation: RandomTimedFlowElement%3EE88F18001E
      //	Constructor. Accepts a Random Generator.
      RandomTimedFlowElement (RandomGenerator* rg);

    //## Destructor (specified)
      //## Operation: ~RandomTimedFlowElement%3EEB2598037A
      //	Destructor. Destroys the owned Random Generator.
      virtual ~RandomTimedFlowElement ();


    //## Other Operations (specified)
      //## Operation: raiseEvent%3EE0A6BB00D2
      //	Raises a new timed Event with the time generated
      //	randomly by the associated Random Generator.
      virtual void raiseEvent (ID id = 0);

    // Additional Protected Declarations
      //## begin RandomTimedFlowElement%3EE08BB1030C.protected preserve=yes
      //## end RandomTimedFlowElement%3EE08BB1030C.protected

  private:
    // Data Members for Associations

      //## Association: Traffic Modeling and Simulation::Concepts::Abstract Concepts::<unnamed>%3EE08F4300F0
      //## Role: RandomTimedFlowElement::rndGen%3EE08F430276
      //## begin RandomTimedFlowElement::rndGen%3EE08F430276.role preserve=no  private: RandomGenerator {0..1 -> 1VFHgAN}
      RandomGenerator *rndGen;
      //## end RandomTimedFlowElement::rndGen%3EE08F430276.role

    // Additional Private Declarations
      //## begin RandomTimedFlowElement%3EE08BB1030C.private preserve=yes
      //## end RandomTimedFlowElement%3EE08BB1030C.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin RandomTimedFlowElement%3EE08BB1030C.implementation preserve=yes
      //## end RandomTimedFlowElement%3EE08BB1030C.implementation

};

//## begin RandomTimedFlowElement%3EE08BB1030C.postscript preserve=yes
//## end RandomTimedFlowElement%3EE08BB1030C.postscript

// Class ModelElement 


//## Other Operations (inline)
inline MEID ModelElement::getID ()
{
  //## begin ModelElement::getID%3EEB0EAE012C.body preserve=yes
	return id;
  //## end ModelElement::getID%3EEB0EAE012C.body
}

inline String ModelElement::getName ()
{
  //## begin ModelElement::getName%3EED840C0320.body preserve=yes
	return name;
  //## end ModelElement::getName%3EED840C0320.body
}

inline String ModelElement::getDescr ()
{
  //## begin ModelElement::getDescr%3EED844800E6.body preserve=yes
	return descr;
  //## end ModelElement::getDescr%3EED844800E6.body
}

// Class FlowElement 

inline FlowElement::FlowElement ()
  //## begin FlowElement::FlowElement%3EE0ABBF0064.hasinit preserve=no
      : counter(0), counter1(0), total(0)
  //## end FlowElement::FlowElement%3EE0ABBF0064.hasinit
  //## begin FlowElement::FlowElement%3EE0ABBF0064.initialization preserve=yes
  , ModelElement(), target(0)
  //## end FlowElement::FlowElement%3EE0ABBF0064.initialization
{
  //## begin FlowElement::FlowElement%3EE0ABBF0064.body preserve=yes
  //## end FlowElement::FlowElement%3EE0ABBF0064.body
}

#include "Sched.h"

//## Other Operations (inline)
inline void FlowElement::acceptFlow ()
{
  //## begin FlowElement::acceptFlow%3EE0834302BC.body preserve=yes
	counter++; 

	// Increase current occurences counter
	counter1++; 
	if (counter1 == VEHICLE_COUNT) {
		t1 = Scheduler::Instance()->getCurTime();
	}
	
	process();
  //## end FlowElement::acceptFlow%3EE0834302BC.body
}

inline void FlowElement::process ()
{
  //## begin FlowElement::process%3EE0AC1B021C.body preserve=yes
  //## end FlowElement::process%3EE0AC1B021C.body
}

inline void FlowElement::send ()
{
  //## begin FlowElement::send%3EE0A68902DA.body preserve=yes

	// Decrease current occurences counter
	counter1--; 
	if (counter1 == VEHICLE_COUNT) {
		t2 = Scheduler::Instance()->getCurTime();
		// Update total time with more than VEHICLE_COUNT occurences at a time
		total += (t2-t1);
	}

	if (target) target->acceptFlow();
  //## end FlowElement::send%3EE0A68902DA.body
}

inline unsigned long FlowElement::getNumOfOccurrences ()
{
  //## begin FlowElement::getNumOfOccurrences%3EE0ABE00302.body preserve=yes
	return counter;
  //## end FlowElement::getNumOfOccurrences%3EE0ABE00302.body
}

inline void FlowElement::resetCounter ()
{
  //## begin FlowElement::resetCounter%3EE0ABE00334.body preserve=yes
	counter = 0; counter1 = 0;
  //## end FlowElement::resetCounter%3EE0ABE00334.body
}

// Class ControlElement 

// Class RandomTimedFlowElement 

inline RandomTimedFlowElement::RandomTimedFlowElement (RandomGenerator* rg)
  //## begin RandomTimedFlowElement::RandomTimedFlowElement%3EE88F18001E.hasinit preserve=no
  //## end RandomTimedFlowElement::RandomTimedFlowElement%3EE88F18001E.hasinit
  //## begin RandomTimedFlowElement::RandomTimedFlowElement%3EE88F18001E.initialization preserve=yes
  : rndGen(rg)
  //## end RandomTimedFlowElement::RandomTimedFlowElement%3EE88F18001E.initialization
{
  //## begin RandomTimedFlowElement::RandomTimedFlowElement%3EE88F18001E.body preserve=yes
  //## end RandomTimedFlowElement::RandomTimedFlowElement%3EE88F18001E.body
}



//## Other Operations (inline)
inline RandomGenerator* RandomTimedFlowElement::getRndGen ()
{
  //## begin RandomTimedFlowElement::getRndGen%3EEE24A203AC.body preserve=yes
	return rndGen;
  //## end RandomTimedFlowElement::getRndGen%3EEE24A203AC.body
}

//## begin module%3EEB3C8E008C.epilog preserve=yes
//## end module%3EEB3C8E008C.epilog


#endif
